function mainWindow
clear; %doesnt hurt, just for testing with F9

%constants
a =605;
b = 405;
difficulty = 6;

r = groot;
scrsz	= r.ScreenSize;
figSize	= [a  b];
mineNum = fliplr(floor((figSize-5)/40));
numMines = floor((mineNum(1)*mineNum(2))/difficulty);
panelColor	= [0.98 0.98 0.98];
figureColor	= [0.9 0.9 0.9];
textColor	= [0.95 0.95 0.95];
textFontSize1  = 9;
textFontSize2  = 10;

% initializing the window with GUI
fig = figure('units', 'pixels', ...
    'Position', [(scrsz(3) - figSize(1))/2, ...
    (scrsz(4) - figSize(2))/2, ...
    figSize(1), figSize(2)], ...
    'Name', 'Minesweeper', 'Tag', 'fig_ex', ...
    'Color', figureColor, 'Menu', 'none', ...
    'NumberTitle', 'off');

%setting up for passing data when leaving this function
myData = fig.UserData;
myData.PlayField = zeros(mineNum);
myData.mineNum = mineNum;
myData.numMines = numMines;
myData.figSize = figSize;
myData.revealAll = 0;
fig.UserData = myData;

myData=generateMinesweeperField(myData);

%creating the visual part of the field
actColumn = 0;
for ii = 5:40:figSize(1)-40
    actColumn = actColumn+1;
    
    actRow = 0;
    for jj = (figSize(2)-5-35):-40:5
        actRow = actRow+1;
        
        
        mField(actRow,actColumn) = uicontrol('Units', 'pixels', ...
            'Position', [ii jj 35 35], ...
            'Style', 'Push', 'String', myData.PlayField(actRow,actColumn), ...
            'ForegroundColor', [0.8 0.9 0.9], ...
            'BackgroundColor', [0.4 0.4 0.4], ...
            'Fontsize', textFontSize1);
        mField(actRow,actColumn).UserData.hasSol = 0;
        if (myData.PlayField(actRow,actColumn)==999)
            mField(actRow,actColumn).String = 'Mine';            
        end
        fieldData = mField(actRow,actColumn).UserData;
        fieldData.String=mField(actRow,actColumn).String;
        fieldData.row = actRow;
        fieldData.column = actColumn;
        mField(actRow,actColumn).UserData = fieldData;
        mField(actRow,actColumn).String = '';
    end
    myData.mField=mField;
    fig.UserData = myData;
    
end

visibleHandle = uicontrol('Units','pixels',...
    'Position',[-500 -500 0.6 0.5], ...
    'Style','check', 'String','Show position',...
    'Tag','choiceOfVisibility', 'BackgroundColor',panelColor,...
    'TooltipString', 'click to show mouse position');
gameStarted = uicontrol('Units','pixels',...
    'Position',[-500 -500 0.6 0.5], ...
    'Style','check', 'String','Show position',...
    'Tag','choiceOfVisibility', 'BackgroundColor',panelColor,...
    'TooltipString', 'click to show mouse position');

%checkong for click on all of my fields
for ii=1:myData.mineNum(1)
    for jj = 1:myData.mineNum(2)
        mField(ii,jj).Callback = {@myFuncPlay, fig,gameStarted};
%         keyboard
        mField(ii,jj).ButtonDownFcn= {@myFuncMine, fig};
        if (fig.UserData.revealAll == 1)
%             fig.UserData.revealAll
        end
    end
end

fig.WindowButtonMotionFcn = {@myFuncSolve, visibleHandle, fig, gameStarted};



%         fig.UserData.revealAll
% keyboard

end